'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MIN_ZOOM = 1;
var MAX_ZOOM = 3;

var Cropper = function (_React$Component) {
  _inherits(Cropper, _React$Component);

  function Cropper() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Cropper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Cropper.__proto__ || Object.getPrototypeOf(Cropper)).call.apply(_ref, [this].concat(args))), _this), _this.image = null, _this.container = null, _this.imageSize = { width: 0, height: 0, naturalWidth: 0, naturalHeight: 0 }, _this.dragStartPosition = { x: 0, y: 0 }, _this.dragStartCrop = { x: 0, y: 0 }, _this.lastPinchDistance = 0, _this.rafTimeout = null, _this.state = {
      cropSize: null
    }, _this.preventZoomSafari = function (e) {
      return e.preventDefault();
    }, _this.cleanEvents = function () {
      document.removeEventListener('mousemove', _this.onMouseMove);
      document.removeEventListener('mouseup', _this.onDragStopped);
      document.removeEventListener('touchmove', _this.onTouchMove);
      document.removeEventListener('touchend', _this.onDragStopped);
    }, _this.onImgLoad = function () {
      _this.computeSizes();
      _this.emitCropData();
    }, _this.computeSizes = function () {
      if (_this.image) {
        _this.imageSize = {
          width: _this.image.width,
          height: _this.image.height,
          naturalWidth: _this.image.naturalWidth,
          naturalHeight: _this.image.naturalHeight
        };
        var cropSize = void 0;
        if (_this.image.width >= _this.image.height * _this.props.aspect) {
          cropSize = {
            width: _this.image.height * _this.props.aspect,
            height: _this.image.height
          };
        } else {
          cropSize = {
            width: _this.image.width,
            height: _this.image.width / _this.props.aspect
          };
        }
        _this.setState({ cropSize: cropSize }, _this.recomputeCropPosition);
      }
    }, _this.onMouseDown = function (e) {
      e.preventDefault();
      document.addEventListener('mousemove', _this.onMouseMove);
      document.addEventListener('mouseup', _this.onDragStopped);
      _this.onDragStart(Cropper.getMousePoint(e));
    }, _this.onMouseMove = function (e) {
      return _this.onDrag(Cropper.getMousePoint(e));
    }, _this.onTouchStart = function (e) {
      e.preventDefault();
      document.addEventListener('touchmove', _this.onTouchMove, { passive: false }); // iOS 11 now defaults to passive: true
      document.addEventListener('touchend', _this.onDragStopped);
      if (e.touches.length === 2) {
        _this.onPinchStart(e);
      } else if (e.touches.length === 1) {
        _this.onDragStart(Cropper.getTouchPoint(e.touches[0]));
      }
    }, _this.onTouchMove = function (e) {
      if (e.touches.length === 2) {
        _this.onPinchMove(e);
      } else if (e.touches.length === 1) {
        _this.onDrag(Cropper.getTouchPoint(e.touches[0]));
      }
    }, _this.onDragStart = function (_ref2) {
      var x = _ref2.x,
          y = _ref2.y;

      _this.dragStartPosition = { x: x, y: y };
      _this.dragStartCrop = { x: _this.props.crop.x, y: _this.props.crop.y };
    }, _this.onDrag = function (_ref3) {
      var x = _ref3.x,
          y = _ref3.y;

      if (_this.rafTimeout) window.cancelAnimationFrame(_this.rafTimeout);

      _this.rafTimeout = window.requestAnimationFrame(function () {
        if (x === undefined || y === undefined) return;
        var offsetX = x - _this.dragStartPosition.x;
        var offsetY = y - _this.dragStartPosition.y;

        _this.props.onCropChange({
          x: Cropper.restrictDrag(_this.dragStartCrop.x + offsetX, _this.imageSize.width, _this.state.cropSize.width, _this.props.zoom),
          y: Cropper.restrictDrag(_this.dragStartCrop.y + offsetY, _this.imageSize.height, _this.state.cropSize.height, _this.props.zoom)
        });
      });
    }, _this.onDragStopped = function () {
      _this.cleanEvents();
      _this.emitCropData();
    }, _this.onWheel = function (e) {
      e.preventDefault();
      var newZoom = _this.props.zoom - e.deltaY / 200;
      _this.setNewZoom(newZoom);
    }, _this.setNewZoom = function (zoom) {
      var newZoom = Math.min(MAX_ZOOM, Math.max(zoom, MIN_ZOOM));
      _this.props.onZoomChange && _this.props.onZoomChange(newZoom);
    }, _this.emitCropData = function () {
      if (!_this.state.cropSize) return;
      var croppedArea = _this.computeCroppedArea();
      var croppedAreaPixels = {
        x: croppedArea.x * _this.imageSize.naturalWidth / 100,
        y: croppedArea.y * _this.imageSize.naturalHeight / 100,
        width: croppedArea.width * _this.imageSize.naturalWidth / 100,
        height: croppedArea.height * _this.imageSize.naturalHeight / 100
      };
      _this.props.onCropComplete && _this.props.onCropComplete(croppedArea, croppedAreaPixels);
    }, _this.computeCroppedArea = function () {
      var _this$props = _this.props,
          _this$props$crop = _this$props.crop,
          x = _this$props$crop.x,
          y = _this$props$crop.y,
          zoom = _this$props.zoom;

      return {
        x: ((_this.imageSize.width - _this.state.cropSize.width / zoom) / 2 - x / zoom) / _this.imageSize.width * 100,
        y: ((_this.imageSize.height - _this.state.cropSize.height / zoom) / 2 - y / zoom) / _this.imageSize.height * 100,
        width: _this.state.cropSize.width / _this.imageSize.width * 100 / zoom,
        height: _this.state.cropSize.height / _this.imageSize.height * 100 / zoom
      };
    }, _this.recomputeCropPosition = function () {
      _this.props.onCropChange({
        x: Cropper.restrictDrag(_this.props.crop.x, _this.imageSize.width, _this.state.cropSize.width, _this.props.zoom),
        y: Cropper.restrictDrag(_this.props.crop.y, _this.imageSize.height, _this.state.cropSize.height, _this.props.zoom)
      });
      _this.emitCropData();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Cropper, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.computeSizes);
      this.container.addEventListener('gesturestart', this.preventZoomSafari);
      this.container.addEventListener('gesturechange', this.preventZoomSafari);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.computeSizes);
      this.container.removeEventListener('gesturestart', this.preventZoomSafari);
      this.container.removeEventListener('gesturechange', this.preventZoomSafari);
      this.cleanEvents();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.zoom !== this.props.zoom) {
        this.recomputeCropPosition();
      }
    }

    // this is to prevent Safari on iOS >= 10 to zoom the page

  }, {
    key: 'onPinchStart',
    value: function onPinchStart(e) {
      var pointA = Cropper.getTouchPoint(e.touches[0]);
      var pointB = Cropper.getTouchPoint(e.touches[1]);
      this.lastPinchDistance = Cropper.getDistanceBetweenPoints(pointA, pointB);
    }
  }, {
    key: 'onPinchMove',
    value: function onPinchMove(e) {
      var _this2 = this;

      if (this.rafTimeout) window.cancelAnimationFrame(this.rafTimeout);
      this.rafTimeout = window.requestAnimationFrame(function () {
        var pointA = Cropper.getTouchPoint(e.touches[0]);
        var pointB = Cropper.getTouchPoint(e.touches[1]);
        var distance = Cropper.getDistanceBetweenPoints(pointA, pointB);

        var newZoom = _this2.props.zoom * (distance / _this2.lastPinchDistance);
        _this2.setNewZoom(newZoom);
        _this2.lastPinchDistance = distance;
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          _props$crop = _props.crop,
          x = _props$crop.x,
          y = _props$crop.y,
          zoom = _props.zoom;

      return _react2.default.createElement(
        _styles.Container,
        {
          onMouseDown: this.onMouseDown,
          onTouchStart: this.onTouchStart,
          onWheel: this.onWheel,
          innerRef: function innerRef(el) {
            return _this3.container = el;
          },
          'data-testid': 'container'
        },
        _react2.default.createElement(_styles.Img, {
          src: this.props.image,
          innerRef: function innerRef(el) {
            return _this3.image = el;
          },
          onLoad: this.onImgLoad,
          alt: '',
          style: {
            transform: 'translate(' + x + 'px, ' + y + 'px) scale(' + zoom + ')'
          }
        }),
        this.state.cropSize && _react2.default.createElement(_styles.CropArea, {
          style: {
            width: this.state.cropSize.width,
            height: this.state.cropSize.height
          },
          'data-testid': 'cropper'
        })
      );
    }
  }], [{
    key: 'restrictDrag',
    value: function restrictDrag(position, imageSize, cropSize, zoom) {
      var maxDrag = imageSize * zoom / 2 - cropSize / 2;
      return Math.min(maxDrag, Math.max(position, -maxDrag));
    }

    /**
     * Compute the cropped area of the image in percent.
     * x and y are the center coordinates of the crop area.
     */

  }]);

  return Cropper;
}(_react2.default.Component);

Cropper.getMousePoint = function (e) {
  return { x: Number(e.clientX), y: Number(e.clientY) };
};

Cropper.getTouchPoint = function (touch) {
  return {
    x: Number(touch.clientX),
    y: Number(touch.clientY)
  };
};

Cropper.getDistanceBetweenPoints = function (pointA, pointB) {
  return Math.sqrt(Math.pow(pointA.y - pointB.y, 2) + Math.pow(pointA.x - pointB.x, 2));
};

Cropper.defaultProps = {
  zoom: 1,
  aspect: 4 / 3
};

exports.default = Cropper;